// Compiled by ClojureScript 0.0-3308 {:elide-asserts true}
goog.provide('com.dreamsoft.calculator.ast');
goog.require('cljs.core');
goog.require('clojure.zip');
goog.require('com.dreamsoft.calculator.token');
/**
 * Test whether or not a value is a zipper
 */
com.dreamsoft.calculator.ast.zipper_QMARK_ = (function com$dreamsoft$calculator$ast$zipper_QMARK_(x){
var in_metadata_QMARK_ = (function (p1__7373_SHARP_){
return cljs.core.contains_QMARK_.call(null,cljs.core.meta.call(null,x),p1__7373_SHARP_);
});
return cljs.core.every_QMARK_.call(null,in_metadata_QMARK_,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword("zip","branch?","zip/branch?",-998880862),new cljs.core.Keyword("zip","children","zip/children",-940194589),new cljs.core.Keyword("zip","make-node","zip/make-node",1103800591)], null));
});
/**
 * Create a new AST with the token as the last child and focus on it
 */
com.dreamsoft.calculator.ast.append_child = (function com$dreamsoft$calculator$ast$append_child(loc0,token){


return clojure.zip.down.call(null,clojure.zip.append_child.call(null,loc0,token));
});
/**
 * Create a new AST with the token as the last sibling and focus on it
 */
com.dreamsoft.calculator.ast.append_sibling = (function com$dreamsoft$calculator$ast$append_sibling(loc1,token){


return clojure.zip.down.call(null,clojure.zip.append_child.call(null,clojure.zip.up.call(null,loc1),token));
});
/**
 * Check whether an AST's node is missing children
 */
com.dreamsoft.calculator.ast.has_enough_children_QMARK_ = (function com$dreamsoft$calculator$ast$has_enough_children_QMARK_(loc2){

var token = clojure.zip.node.call(null,loc2);
var children = clojure.zip.children.call(null,loc2);
return (cljs.core.count.call(null,children) >= cljs.core.get.call(null,com.dreamsoft.calculator.token.children_needed,token));
});
/**
 * Check where the current number contains a dot
 */
com.dreamsoft.calculator.ast.contains_dot_QMARK_ = (function com$dreamsoft$calculator$ast$contains_dot_QMARK_(loc3){

var loc3__$1 = loc3;
while(true){
var current = clojure.zip.node.call(null,loc3__$1);
if(cljs.core.truth_(com.dreamsoft.calculator.token.dot_QMARK_.call(null,current))){
return true;
} else {
if((clojure.zip.down.call(null,loc3__$1) == null)){
return false;
} else {
var G__7374 = clojure.zip.down.call(null,loc3__$1);
loc3__$1 = G__7374;
continue;

}
}
break;
}
});
/**
 * Ignore a token and log the current AST state
 */
com.dreamsoft.calculator.ast.ignore_token = (function com$dreamsoft$calculator$ast$ignore_token(loc4,token){


var parent = clojure.zip.up.call(null,loc4);
var children = clojure.zip.children.call(null,clojure.zip.up.call(null,loc4));
cljs.core.prn.call(null,[cljs.core.str("invalid operator '"),cljs.core.str(token),cljs.core.str("' inserted under '"),cljs.core.str(parent),cljs.core.str("' with siblings '"),cljs.core.str(children),cljs.core.str("'")].join(''));

return loc4;
});
/**
 * Create a new AST with the specified token as parent
 * and the old AST as first child
 */
com.dreamsoft.calculator.ast.make_parent = (function com$dreamsoft$calculator$ast$make_parent(loc5,x){


return clojure.zip.edit.call(null,loc5,(function (children){
return cljs.core.conj.call(null,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [x], null),children);
}));
});
/**
 * Grab the parent node
 */
com.dreamsoft.calculator.ast.parent = (function com$dreamsoft$calculator$ast$parent(loc6){

return clojure.zip.node.call(null,clojure.zip.up.call(null,loc6));
});
/**
 * Create a new single token AST
 */
com.dreamsoft.calculator.ast.singleton = (function com$dreamsoft$calculator$ast$singleton(val){

return clojure.zip.vector_zip.call(null,val);
});
/**
 * Check whether a AST node is the top node
 */
com.dreamsoft.calculator.ast.top_QMARK_ = (function com$dreamsoft$calculator$ast$top_QMARK_(loc7){

return (clojure.zip.up.call(null,loc7) == null);
});
/**
 * Create a new AST with the closest parent matching the predicate focused on
 */
com.dreamsoft.calculator.ast.closest_parent_match = (function com$dreamsoft$calculator$ast$closest_parent_match(loc8,pred){

var current = loc8;
while(true){
if(cljs.core.truth_(com.dreamsoft.calculator.ast.top_QMARK_.call(null,clojure.zip.node.call(null,current)))){
return loc8;
} else {
if(cljs.core.truth_(pred.call(null,clojure.zip.node.call(null,current)))){
return current;
} else {
var G__7375 = clojure.zip.up.call(null,current);
current = G__7375;
continue;

}
}
break;
}
});
com.dreamsoft.calculator.ast.insert_digit = (function com$dreamsoft$calculator$ast$insert_digit(loc9,digit){


var current = clojure.zip.node.call(null,loc9);
if(cljs.core.truth_((function (){var or__4309__auto__ = com.dreamsoft.calculator.token.operator_QMARK_.call(null,current);
if(cljs.core.truth_(or__4309__auto__)){
return or__4309__auto__;
} else {
return com.dreamsoft.calculator.token.open_parenthesis_QMARK_.call(null,current);
}
})())){
if(cljs.core.truth_(com.dreamsoft.calculator.ast.has_enough_children_QMARK_.call(null,current))){
return com.dreamsoft.calculator.ast.ignore_token.call(null,loc9,com.dreamsoft.calculator.token.dot);
} else {
return com.dreamsoft.calculator.ast.append_child.call(null,loc9,digit);
}
} else {
if(cljs.core.truth_(com.dreamsoft.calculator.token.digit_QMARK_.call(null,cljs.core.first.call(null,current)))){
return clojure.zip.edit.call(null,loc9,com.dreamsoft.calculator.token.append_digits,digit);
} else {
return null;
}
}
});
com.dreamsoft.calculator.ast.insert_dot = (function com$dreamsoft$calculator$ast$insert_dot(loc10){

var current = clojure.zip.node.call(null,loc10);
if(cljs.core.truth_((function (){var or__4309__auto__ = com.dreamsoft.calculator.token.operator_QMARK_.call(null,current);
if(cljs.core.truth_(or__4309__auto__)){
return or__4309__auto__;
} else {
return com.dreamsoft.calculator.token.open_parenthesis_QMARK_.call(null,current);
}
})())){
if(cljs.core.truth_(com.dreamsoft.calculator.ast.has_enough_children_QMARK_.call(null,current))){
return com.dreamsoft.calculator.ast.ignore_token.call(null,loc10,com.dreamsoft.calculator.token.dot);
} else {
return com.dreamsoft.calculator.ast.append_child.call(null,loc10,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [com.dreamsoft.calculator.token.dot,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, ["0"], null)], null));
}
} else {
if(cljs.core.truth_(com.dreamsoft.calculator.token.digit_QMARK_.call(null,cljs.core.first.call(null,current)))){
if(cljs.core.truth_(com.dreamsoft.calculator.ast.contains_dot_QMARK_.call(null,current))){
return loc10;
} else {
return clojure.zip.edit.call(null,loc10,com.dreamsoft.calculator.token.append_digits,com.dreamsoft.calculator.token.dot);
}
} else {
return null;
}
}
});
com.dreamsoft.calculator.ast.insert_open_parenthesis = (function com$dreamsoft$calculator$ast$insert_open_parenthesis(loc11){

var current = clojure.zip.node.call(null,loc11);
if(cljs.core.truth_(com.dreamsoft.calculator.token.operator_QMARK_.call(null,current))){
if(cljs.core.truth_(com.dreamsoft.calculator.ast.has_enough_children_QMARK_.call(null,loc11))){
return com.dreamsoft.calculator.ast.ignore_token.call(null,loc11,com.dreamsoft.calculator.token.open_parenthesis);
} else {
return com.dreamsoft.calculator.ast.append_child.call(null,loc11,com.dreamsoft.calculator.token.open_parenthesis);
}
} else {
return null;
}
});
com.dreamsoft.calculator.ast.insert_operator = (function com$dreamsoft$calculator$ast$insert_operator(loc12,operator){


var current = clojure.zip.node.call(null,loc12);
if(cljs.core.truth_(com.dreamsoft.calculator.token.operator_QMARK_.call(null,current))){
return clojure.zip.replace.call(null,loc12,operator);
} else {
if(cljs.core.truth_(com.dreamsoft.calculator.token.open_parenthesis_QMARK_.call(null,current))){
return com.dreamsoft.calculator.ast.append_child.call(null,loc12,operator);
} else {
if(cljs.core.truth_(com.dreamsoft.calculator.token.digit_QMARK_.call(null,cljs.core.first.call(null,current)))){
if(cljs.core.truth_(com.dreamsoft.calculator.ast.top_QMARK_.call(null,loc12))){
return com.dreamsoft.calculator.ast.make_parent.call(null,loc12,operator);
} else {
return com.dreamsoft.calculator.ast.ignore_token.call(null,loc12,operator);
}
} else {
return null;
}
}
}
});
/**
 * Create a new AST with the token inserted
 */
com.dreamsoft.calculator.ast.insert_token = (function com$dreamsoft$calculator$ast$insert_token(loc13,x){


if(cljs.core.truth_(com.dreamsoft.calculator.token.open_parenthesis_QMARK_.call(null,x))){
com.dreamsoft.calculator.ast.insert_open_parenthesis.call(null,loc13);
} else {
if(cljs.core.truth_(com.dreamsoft.calculator.token.close_parenthesis_QMARK_.call(null,x))){
com.dreamsoft.calculator.ast.closest_parent_match.call(null,loc13,com.dreamsoft.calculator.token.open_parenthesis_QMARK_);
} else {
if(cljs.core.truth_(com.dreamsoft.calculator.token.operator_QMARK_.call(null,x))){
com.dreamsoft.calculator.ast.insert_operator.call(null,loc13,x);
} else {
if(cljs.core.truth_(com.dreamsoft.calculator.token.digit_QMARK_.call(null,x))){
com.dreamsoft.calculator.ast.insert_digit.call(null,loc13,x);
} else {
if(cljs.core.truth_(com.dreamsoft.calculator.token.dot_QMARK_.call(null,x))){
com.dreamsoft.calculator.ast.insert_dot.call(null,loc13);
} else {
}
}
}
}
}


return com.dreamsoft.calculator.ast.ignore_token.call(null,loc13,x);
});
