(ns com.dreamsoft.calculator.core
	"Main namespace of the calculator and entry point of it"
	(:require [reagent.core :as rc]
			  [clojure.browser.repl :refer [connect]]
	          [com.dreamsoft.calculator.ast :as ast]
	          [com.dreamsoft.calculator.bignum :as bignum]
	          [com.dreamsoft.calculator.token :as token]
		      [com.dreamsoft.calculator.ui :as ui]))

; defines the initial state which is a single element tree of value `0`
(defonce state (rc/atom (ast/singleton "0")))

(defn handler [symbol]
	(swap! state ast/insert-token symbol))

(def buttons
	(for [symbol (concat token/figures [token/dot] token/operators)]
		(ui/button symbol handler)))

(defn main- []
	(rc/render-component [ui/page state buttons] (.-body js/document)))

; for fast debugging and 'Read-Eval-Print-Loop'
(connect "http://localhost:9000/repl")

(enable-console-print!)

; calls the "main" function to load the calculator
(main-)
