// Compiled by ClojureScript 0.0-3308 {:elide-asserts true}
goog.provide('com.dreamsoft.calculator.eval');
goog.require('cljs.core');
goog.require('clojure.string');
goog.require('clojure.walk');
goog.require('com.dreamsoft.calculator.bignum');
goog.require('com.dreamsoft.calculator.token');
/**
 * Mapping between tokens and evaluating functions
 */
com.dreamsoft.calculator.eval.operators_mapping = new cljs.core.PersistentArrayMap.fromArray([com.dreamsoft.calculator.token.plus,com.dreamsoft.calculator.bignum.plus,com.dreamsoft.calculator.token.minus,com.dreamsoft.calculator.bignum.minus,com.dreamsoft.calculator.token.times,com.dreamsoft.calculator.bignum.times,com.dreamsoft.calculator.token.divided,com.dreamsoft.calculator.bignum.divided], true, false);
/**
 * Specific function to evaluate numbers
 */
com.dreamsoft.calculator.eval.eval_number = (function com$dreamsoft$calculator$eval$eval_number(node){


var acc = cljs.core.PersistentVector.EMPTY;
var G__13002 = node;
var vec__13003 = G__13002;
var x = cljs.core.nth.call(null,vec__13003,(0),null);
var xs = cljs.core.nthnext.call(null,vec__13003,(1));
var acc__$1 = acc;
var G__13002__$1 = G__13002;
while(true){
var acc__$2 = acc__$1;
var vec__13004 = G__13002__$1;
var x__$1 = cljs.core.nth.call(null,vec__13004,(0),null);
var xs__$1 = cljs.core.nthnext.call(null,vec__13004,(1));
if(cljs.core.empty_QMARK_.call(null,xs__$1)){
return com.dreamsoft.calculator.bignum.bignum.call(null,clojure.string.join.call(null,cljs.core.conj.call(null,acc__$2,x__$1)));
} else {
var G__13005 = cljs.core.conj.call(null,acc__$2,x__$1);
var G__13006 = xs__$1;
acc__$1 = G__13005;
G__13002__$1 = G__13006;
continue;
}
break;
}
});
/**
 * Specific function to evaluate operators
 */
com.dreamsoft.calculator.eval.eval_operator = (function com$dreamsoft$calculator$eval$eval_operator(node){


var operator = cljs.core.get.call(null,com.dreamsoft.calculator.eval.operators_mapping,cljs.core.first.call(null,node));
return cljs.core.apply.call(null,operator,cljs.core.map.call(null,com.dreamsoft.calculator.eval.eval,cljs.core.rest.call(null,node)));
});
/**
 * Specific function to evaluate parenthesis
 */
com.dreamsoft.calculator.eval.eval_parenthesis = (function com$dreamsoft$calculator$eval$eval_parenthesis(node){

return com.dreamsoft.calculator.eval.eval.call(null,cljs.core.rest.call(null,node));
});
/**
 * Main generic function to evaluate the AST by 'dispatching' on cases
 */
com.dreamsoft.calculator.eval.eval = (function com$dreamsoft$calculator$eval$eval(node){

var operation = cljs.core.first.call(null,node);
if(cljs.core.truth_(com.dreamsoft.calculator.token.digit_QMARK_.call(null,operation))){
return com.dreamsoft.calculator.eval.eval_number.call(null,node);
} else {
if(cljs.core.truth_(com.dreamsoft.calculator.token.open_parenthesis_QMARK_.call(null,operation))){
return com.dreamsoft.calculator.eval.eval_parenthesis.call(null,node);
} else {
if(cljs.core.truth_(com.dreamsoft.calculator.token.operator_QMARK_.call(null,operation))){
return com.dreamsoft.calculator.eval.eval_operator.call(null,node);
} else {
return null;
}
}
}
});
