// Compiled by ClojureScript 0.0-3308 {:elide-asserts true}
goog.provide('com.dreamsoft.calculator.token');
goog.require('cljs.core');
/**
 * The valid dot token
 */
com.dreamsoft.calculator.token.dot = ".";
/**
 * A vector of all valid number figure tokens
 */
com.dreamsoft.calculator.token.figures = new cljs.core.PersistentVector(null, 10, 5, cljs.core.PersistentVector.EMPTY_NODE, ["0","1","2","3","4","5","6","7","8","9"], null);
com.dreamsoft.calculator.token.plus = "+";
com.dreamsoft.calculator.token.minus = "-";
com.dreamsoft.calculator.token.times = "\u00D7";
com.dreamsoft.calculator.token.divided = "\u00F7";
/**
 * A vector of all valid operator tokens
 */
com.dreamsoft.calculator.token.operators = new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [com.dreamsoft.calculator.token.plus,com.dreamsoft.calculator.token.minus,com.dreamsoft.calculator.token.times,com.dreamsoft.calculator.token.divided], null);
/**
 * The valid open-parenthesis token
 */
com.dreamsoft.calculator.token.open_parenthesis = "(";
/**
 * The valid close-parenthesis token
 */
com.dreamsoft.calculator.token.close_parenthesis = ")";
com.dreamsoft.calculator.token.children_needed = new cljs.core.PersistentArrayMap.fromArray([com.dreamsoft.calculator.token.plus,(2),com.dreamsoft.calculator.token.minus,(2),com.dreamsoft.calculator.token.times,(2),com.dreamsoft.calculator.token.divided,(2),com.dreamsoft.calculator.token.open_parenthesis,(1)], true, false);
/**
 * Check whether a token is a digit
 */
com.dreamsoft.calculator.token.digit_QMARK_ = (function com$dreamsoft$calculator$token$digit_QMARK_(token){

return cljs.core.contains_QMARK_.call(null,cljs.core.set.call(null,com.dreamsoft.calculator.token.figures),token);
});
/**
 * Create a new digits token with a figure appended
 */
com.dreamsoft.calculator.token.append_digits = (function com$dreamsoft$calculator$token$append_digits(digits,token){


return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [token,digits], null);
});
/**
 * Check whether a token is a close-parenthesis
 */
com.dreamsoft.calculator.token.close_parenthesis_QMARK_ = (function com$dreamsoft$calculator$token$close_parenthesis_QMARK_(token){

return cljs.core._EQ_.call(null,token,com.dreamsoft.calculator.token.close_parenthesis);
});
/**
 * Check whether a token is a dot
 */
com.dreamsoft.calculator.token.dot_QMARK_ = (function com$dreamsoft$calculator$token$dot_QMARK_(token){

return cljs.core._EQ_.call(null,token,com.dreamsoft.calculator.token.dot);
});
/**
 * Check whether a token is an operator
 */
com.dreamsoft.calculator.token.operator_QMARK_ = (function com$dreamsoft$calculator$token$operator_QMARK_(token){

return cljs.core.contains_QMARK_.call(null,com.dreamsoft.calculator.token.operators,token);
});
/**
 * Check whether a token is an open-parenthesis
 */
com.dreamsoft.calculator.token.open_parenthesis_QMARK_ = (function com$dreamsoft$calculator$token$open_parenthesis_QMARK_(token){

return cljs.core._EQ_.call(null,token,com.dreamsoft.calculator.token.open_parenthesis);
});
/**
 * Check whether or not a subtree is only made of dots and digits
 */
com.dreamsoft.calculator.token.only_digits_QMARK_ = (function com$dreamsoft$calculator$token$only_digits_QMARK_(node){

var G__7693 = node;
var vec__7694 = G__7693;
var x = cljs.core.nth.call(null,vec__7694,(0),null);
var xs = cljs.core.nthnext.call(null,vec__7694,(1));
var G__7693__$1 = G__7693;
while(true){
var vec__7695 = G__7693__$1;
var x__$1 = cljs.core.nth.call(null,vec__7695,(0),null);
var xs__$1 = cljs.core.nthnext.call(null,vec__7695,(1));
if(cljs.core.truth_(cljs.core.some_fn.call(null,com.dreamsoft.calculator.token.digit_QMARK_,com.dreamsoft.calculator.token.dot_QMARK_).call(null,x__$1))){
var G__7696 = xs__$1;
G__7693__$1 = G__7696;
continue;
} else {
if(cljs.core.empty_QMARK_.call(null,xs__$1)){
return true;
} else {
return false;

}
}
break;
}
});
